(define selfmenuroot "<Image>/Filters/Test for Duplicate scripts")     ; Change these to suit yourself         
(define selfmenuentry "Test For Duplicate Scripts...")

(define selfauthor "Kevin Payne")
(define selfcopyright "Copyright (C) 2011 Kevin Payne paynekj@hotmail.com")

;
; Version 1.0 09.11.2011 First version
(define selffileversion "09.11.2011 Version 1.0 - First attempt")

(define selffilename "\n- kp24_test_for_duplicate_scripts.scm")

(define selftipstrip (string-append "Test for duplicate scripts" "\n\n\nRegisters in menu " selfmenuroot  "/" selfmenuentry "\n\nScript File name - " selffilename))

(define (script-fu-kp24_test_for_duplicate_scripts dirpath)
  (let* ( 
           (found 0) (found_remainder '()) (list_ref 0)
           (token "")
           (stream 0)
           (proc_name_list '()) (proc_name "")
           (filepath_list '())
           (varFileList (cadr (file-glob (string-append dirpath DIR-SEPARATOR "*.scm") 1) ) ) ; Get the list of script files 
	)
	(for-each                      ; step through each of the script files
	  (lambda (filepath)
            (set! found 0)                            ; flag to indicate if we've found what what we're looking for
            (set! stream (open-input-file filepath))  ; open the script file
            (while (= found 0)                        ; loop round until we've found what what we're looking for
              (begin
                (set! token (read stream))            ; read a section from the script file
                (if (list? token)                     ; if we've got something useful
                  (if (string=? (symbol->string (car token)) "script-fu-register")  ; check if this section is what we want
                    (begin
                      (set! found 1)                                                         ; sucess, it's a register section
                      (set! proc_name (car (cdr token)))                                     ; extract the procedure name
                      (if (symbol? proc_name) (set! proc_name (symbol->string proc_name))  ) ; make sure we've got a string
                      (set! found_remainder (member proc_name proc_name_list))               ; is this procedure already in the list?
                      (if (list? found_remainder)
                        (begin                                                                   ; Yes, we've found this procedure before
                          (set! list_ref (- (length proc_name_list) (length found_remainder)))   ; find the list index of the previous occurence
                          (gimp-message (string-append "duplicate: " proc_name " in \n" filepath "\n and \n" (list-ref filepath_list list_ref) )) ; Already found this name
                        )
                        (begin                                                           ; we didn't find the procedure before
                          (set! proc_name_list (append proc_name_list (list proc_name))) ; New name so add to list
                          (set! filepath_list (append filepath_list (list filepath)))    ; remember which file it was in
                        )
                      )
                    )
                  )
                  (set! found 1) ; We ran out of file
                )
              )
            )
            (close-input-port stream)  ; close the script file
          )
          varFileList
        )
        (gimp-message "Finished checking for duplicates")
  )
)

(script-fu-register "script-fu-kp24_test_for_duplicate_scripts"
		    selfmenuentry
		    selftipstrip
		    selfcopyright
		    selfauthor
		    selffileversion
		    ""
                    SF-DIRNAME "Directory" (string-append gimp-directory DIR-SEPARATOR "scripts")
		    )

(script-fu-menu-register "script-fu-kp24_test_for_duplicate_scripts" selfmenuroot)
